<?php

// ...  doesn't really matter - nothing bad can be done by directly accessing this file :P
//if(!defined('IN_MYBB'))
//	die('Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.');

define('PREPARSE_PLUGIN_FILE', MYBB_ROOT.'inc/preparser_plugin.php');

if(defined('IN_ADMINCP'))
{
	require PREPARSE_PLUGIN_FILE;
}

$plugins->add_hook('datahandler_post_insert_post', 'preparse_post_new', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('datahandler_post_insert_thread_post', 'preparse_post_new', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('datahandler_post_update', 'preparse_post_update', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('class_moderation_merge_posts', 'preparse_post_merge', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('class_moderation_delete_post', 'preparse_post_delete', 10, PREPARSE_PLUGIN_FILE);

$plugins->add_hook('datahandler_post_insert_thread', 'thread_hardfilter', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('datahandler_post_update_thread', 'thread_update_hardfilter', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('usercp_do_editsig_process', 'sig_update', 10, PREPARSE_PLUGIN_FILE);

$plugins->add_hook('datahandler_user_insert', 'user_parse', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('datahandler_user_update', 'user_parse', 10, PREPARSE_PLUGIN_FILE);


$plugins->add_hook('showthread_start', 'preparse_showthread');

$plugins->add_hook('newreply_start', 'preparse_include_parser', 10, PREPARSE_PLUGIN_FILE);
$plugins->add_hook('member_do_emailuser_start', 'preparse_include_parser', 10, PREPARSE_PLUGIN_FILE);


function preparse_prune_cache()
{
	global $db, $mybb;
	$cutoff = $_SERVER['REQUEST_TIME'] - intval($mybb->settings['preparse_time']) * 86400;
	$db->delete_query(TABLE_PREFIX.'parsed_posts', 'lastparse < '.$cutoff);
	$db->delete_query(TABLE_PREFIX.'parsed_sigs', 'lastparse < '.$cutoff);
}

// updates the "last parse" time, when viewing posts/sigs
function preparse_updatetime()
{
	global $preparse_postcache, $db;
	$update_array = array('lastparse' => $_SERVER['REQUEST_TIME']);
	$db->update_query(TABLE_PREFIX.'parsed_posts', $update_array, 'pid IN ('.implode(',',array_keys($preparse_postcache)).')');
	$db->update_query(TABLE_PREFIX.'parsed_sigs', $update_array, 'uid IN ('.implode(',',$preparse_postcache).')');
}
function preparse_updatetime_cacheposts($post)
{
	// this variable will simply hold an array of the PIDs (as keys) and UIDs (as values)
	global $preparse_postcache;
	if(!is_array($preparse_postcache)) $preparse_postcache = array();
	$preparse_postcache[$post['pid']] = $post['uid'];
}

function preparse_updatetime_threaded()
{
	global $showpost, $db;
	$update_array = array('lastparse' => $_SERVER['REQUEST_TIME']);
	$db->update_query(TABLE_PREFIX.'parsed_posts', $update_array, 'pid='.$showpost['pid']);
	$db->update_query(TABLE_PREFIX.'parsed_sigs', $update_array, 'uid='.$showpost['uid']);
}

function preparse_showthread()
{
	global $plugins, $rand, $mybb;
	if($rand < 5)
	{
		if($mybb->input['mode'] == 'threaded')
		{
			$plugins->add_hook('showthread_threaded', 'preparse_updatetime_threaded');
		}
		else
		{
			$plugins->add_hook('showthread_linear', 'preparse_updatetime');
			$plugins->add_hook('postbit', 'preparse_updatetime_cacheposts');
		}
	}
	elseif($rand < 6)
	{
		$plugins->add_hook('showthread_end', 'preparse_prune_cache');
	}
}


function update_parsed_post($pid, &$pdata)
{
	global $db, $parser, $parser_options, $preparse_inserts;
	if(!isset($parser))
	{
		require_once MYBB_ROOT.'inc/class_parser.php';
		$parser = new postParser;
	}
	
	if(empty($parser_options))
	{
		$forum = get_forum($pdata['fid']);
		$parser_options = array(
			'allow_html' => $forum['allowhtml'],
			'allow_mycode' => $forum['allowmycode'],
			'allow_smilies' => $forum['allowsmilies'],
			'allow_imgcode' => $forum['allowimgcode']
		);
		if(isset($pdata['username']))
			$parser_options['me_username'] = $pdata['username'];
		elseif($pdata['uid']) //portal?
		{
			$tempu = get_user($pdata['uid']);
			$parser_options['me_username'] = $tempu['username'];
		}
		else // xmlhttp editing
		{
			global $mybb;
			$parser_options['me_username'] = $mybb->user['username'];
		}
		
		if($pdata['similieoff'] == 'yes' || $pdata['options']['disablesmilies'] == 'yes')
			$parser_options['allow_smilies'] = 'no';
	}
	
	$parsed_data = $parser->parse_message($pdata['message'], $parser_options);
	
	$preparse_inserts['parsed_posts'][$pid] = array(
		'pid' => $pid,
		'parsedmessage' => $db->escape_string($parsed_data),
		'lastparse' => $_SERVER['REQUEST_TIME']
	);
	add_shutdown('preparse_shutdown_update');
	return $parsed_data;
}

function update_parsed_sig($user)
{
	global $db, $parser, $sig_parser, $preparse_inserts;
	if(!isset($parser))
	{
		require_once MYBB_ROOT.'inc/class_parser.php';
		$parser = new postParser;
	}
	
	if(empty($sig_parser))
	{
		global $mybb;
		$sig_parser = array(
			'allow_html' => $mybb->settings['sightml'],
			'allow_mycode' => $mybb->settings['sigmycode'],
			'allow_smilies' => $mybb->settings['sigsmilies'],
			'allow_imgcode' => $mybb->settings['sigimgcode']
		);
		if($user['username'])
			$sig_parser['me_username'] = $user['username'];
		elseif($user['uid'])
		{
			// use this hack
			$tempu = get_user(intval($user['uid']));
			$sig_parser['me_username'] = $tempu['username'];
		}
	}
	
	$parsed_data = $parser->parse_message($user['signature'], $sig_parser);
	
	$preparse_inserts['parsed_sigs'][$user['uid']] = array(
		'uid' => $user['uid'],
		'parsedsig' => $db->escape_string($parsed_data),
		'lastparse' => $_SERVER['REQUEST_TIME']
	);
	add_shutdown('preparse_shutdown_update');
	return $parsed_data;
}


function preparse_shutdown_update()
{
	global $preparse_inserts;
	static $shutdown_done;
	if(isset($shutdown_done) || !is_array($preparse_inserts)) return;
	
	foreach($preparse_inserts as $table => $rows)
		preparse_db_replace_rows($table, $rows);
	
	unset($GLOBALS['preparse_inserts']);
	unset($preparse_inserts);
	$shutdown_done = true;
}


// multi-row REPLACE INTO
function preparse_db_replace_rows($table, $rows)
{
	global $db;
	
	$insertsql = '';
	foreach($rows as $row)
		$insertsql .= '(\''.implode('\',\'', $row).'\'),';
	// remove trailing comma
	return $db->query('REPLACE INTO '.TABLE_PREFIX.$table
		.'('.implode(',', array_keys(reset($rows))).')
		VALUES '.substr($insertsql, 0, -1));
}


?>